RINT(3)

NAME
nearbyint, nearbyintf, nearbyintl, rint, rintf, rintl - round to nearest integer

SYNOPSIS
#include <math.h>

double nearbyint(double x);
float nearbyintf(float x);
long double nearbyintl(long double x);

double rint(double x);
float rintf(float x);
long double rintl(long double x);

Link with -lm.

DESCRIPTION
The nearbyint functions round their argument to an integer value in floating point format, using the current rounding direction and without raising the inexact exception.

The rint functions do the same, but will raise the inexact exception when the result differs in value from the argument.

RETURN VALUE
The rounded integer value. If x is integral or infinite, x itself is returned.

ERRORS
No errors other than EDOM and ERANGE can occur. If x is NaN, then NaN is returned and errno may be set to EDOM.

NOTES
SUSv2 and POSIX 1003.1-2001 contain text about overflow (which might set errno to ERANGE, or raise an exception). In practice, the result cannot overflow on any current machine, so this error-handling stuff is just nonsense. (More precisely, overflow can happen only when the maximum value of the exponent is smaller than the number of mantissa bits. For the IEEE-754 standard 32-bit and 64-bit floating point numbers the maximum value of the exponent is 128 (resp. 1024), and the number of mantissa bits is 24 (resp. 53).)

CONFORMING TO
The rint() function conforms to BSD 4.3. The other functions are from C99.

SEE ALSO
ceil(3), floor(3), lrint(3), nearbyint(3), round(3), trunc(3)